//       
const string dummy_node = "_dummynode"; 
//,       
const string node_needToBePopulated = "_populateMe";
//,         
const string nodeText_Neighborhoods = "Neighborhoods";
const string nodeText_Prices = "Prices";
const string nodeText_HouseType = "HouseTypes";

//--------------------------------------------------------------------
//    
//
//    TreeView   
//  
//--------------------------------------------------------------------
  private void button1_Click(object sender, System.EventArgs e)
{
  TreeNode tnNewNode;
  
  //     ,  
  //  
  treeView1.BeginUpdate();
  //   
  treeView1.Nodes.Clear();
  //-----------------------------
  // "Neighborhoods"
  //-----------------------------
  //  "Neighborhoods"  .
  tnNewNode = treeView1.Nodes.Add("Neighborhoods");

  //   ,   ,   
  //  
  tnNewNode.Tag = node_needToBePopulated ; 
  //       ,  
  // ,   ,      
  // .
  tnNewNode.Nodes.Add(dummy_node);

  //-----------------------------
  // "Price"
  //-----------------------------
  tnNewNode = treeView1.Nodes.Add("Price");

  //   ,   ,   
  //  
  tnNewNode.Tag = node_needToBePopulated ; 

  //       ,  
  // ,   ,      
  // .
  tnNewNode.Nodes.Add(dummy_node);

  //-----------------------------
  // "HouseType"
  //-----------------------------
  tnNewNode = treeView1.Nodes.Add("HouseType");

  //   ,   ,   
  //  
  tnNewNode.Tag = node_needToBePopulated ; 

  //       ,  
  // ,   ,      
  // .
  tnNewNode.Nodes.Add(dummy_node );

  //  
  treeView1.EndUpdate();
}

//-----------------------------------------------------------------------------
//  BeforeExpand     TreeView
//:     
//                InitializeComponent()
//            . 
//
//     ,   , 
//  ,   .     
//         
//   TreeView.
//-----------------------------------------------------------------------------
private void TreeView1BeforeExpand
(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
{
  // ,   
  System.Windows.Forms.TreeNode tnExpanding;
  tnExpanding = e.Node;

  //     "   ",
  //      , "  ".
  if(tnExpanding.Tag != (object) node_needToBePopulated)
  {
    return; //   
  }

  //------------------------------------------------------------
  //    .
  // ,      ; ,
  //   
  //------------------------------------------------------------
  if(tnExpanding.Text == nodeText_Neighborhoods)
  {
    PopulateTreeViewNeighborhoods(tnExpanding);
    return; //  !
  }
  else
  {
    //     ,   
    //.
    System.Windows.Forms.MessageBox.Show(
     " :       ");

      //    ,       
      // 
      tnExpanding.Tag = "";
  }
}

//------------------------------------------------------------------
//       
//  "Neighborhood"
//------------------------------------------------------------------
void PopulateTreeViewNeighborhoods(TreeNode tnAddTo)
{
  TreeView tvControl;
  tvControl = tnAddTo.TreeView;
  
  tvControl.BeginUpdate();
  //   
  tnAddTo.Nodes.Clear();
  
  //  ,      
  // ,   .
  TreeNode [] newNeighborhoodNodes;
  newNeighborhoodNodes = new TreeNode[4];
  newNeighborhoodNodes[0] = new TreeNode("Capitol Hill");
  newNeighborhoodNodes[1] = new TreeNode("Chelsea");
  newNeighborhoodNodes[2] = new TreeNode("Downtown");
  newNeighborhoodNodes[3] = new TreeNode("South Bay");
  //      TreeView
  tnAddTo.Nodes.AddRange(newNeighborhoodNodes);
  
  tvControl.EndUpdate();
}
