//   
public class myButton : System.Windows.Forms.Control
{
//-------------------------------------------------------
//,    
//-------------------------------------------------------
System.Drawing.Brush m_RectangleBrush;
System.Drawing.Brush m_TextBrush;
System.Drawing.Color m_RectangleColor;

//------------------------------------------------------------------------
//,      .  -  
//.
//------------------------------------------------------------------------
public event System.EventHandler EventButtonTurningBlue;
  
//
public myButton() : base()
{
  //:     Dispose() 
  //,      
  
  //  
  m_RectangleColor = System.Drawing.Color.Black;
  
  m_RectangleBrush = new System.Drawing.SolidBrush(
                          m_RectangleColor);
                          
  m_TextBrush = new System.Drawing.SolidBrush(
                          System.Drawing.Color.White);    
}


//-------------------------------------------------------
//    
//      
//-------------------------------------------------------
protected override void OnClick(System.EventArgs e)
{
  //--------------------------------------------------------
  //:   . 
  //     ,
  //    
  //--------------------------------------------------------
  base.OnClick(e);
  
  //--------------------------------------------------------
  //   ,     
  //--------------------------------------------------------
  if (m_RectangleColor == System.Drawing.Color.Black)
  {
    m_RectangleColor = System.Drawing.Color.Blue;

    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    // !
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if(EventButtonTurningBlue!= null)
    {
      //    
      EventButtonTurningBlue(this, null);
    }
  }
  else if (m_RectangleColor == System.Drawing.Color.Blue)
  {
    m_RectangleColor = System.Drawing.Color.Red;
  }
  else
  {
    m_RectangleColor = System.Drawing.Color.Black;
    }

  //------------------------------------------------
  //  
  //------------------------------------------------
  m_RectangleBrush.Dispose();

  //----------------------------------------------------------------
  //  ,      
  //----------------------------------------------------------------
  m_RectangleBrush = 
    new System.Drawing.SolidBrush(m_RectangleColor);

  //------------------------------------------------------------
  //  ,    
  //  ,    
  //------------------------------------------------------------
  this.Invalidate();
}

//-------------------------------------------------------------------------
//  ,    
//-------------------------------------------------------------------------
int m_paintCount;
protected override void OnPaint(
                    System.Windows.Forms.PaintEventArgs e)
{
  //---------------------------------------------------------
  //:      
  //   
  //---------------------------------------------------------
  base.OnPaint(e);

  //     
  m_paintCount = m_paintCount + 1;

  //--------------------------------------------------------------------------
  //:
  //     Graphics,   
  //   .  ,     
  // .Dispose()  -   
  //--------------------------------------------------------------------------
  System.Drawing.Graphics myGfx;
  myGfx = e.Graphics;

  // 
  myGfx.FillRectangle(m_RectangleBrush, 0,0, 
                      this.Width, this.Height);
  // 
  myGfx.DrawString("Button! Paint: " + m_paintCount.ToString(),
                   this.Parent.Font, m_TextBrush,0,0);
} // 
} // 
