// DataSet,    
System.Data.DataSet m_myDataSet;
//,   
const string FILE_EMPTY_DATASET = "EmptyDataSet.xml";
const string FILE_1TABLE_DATASET = "1TableDataSet.xml";
const string dividerLine = "-----------------------------\r\n";
const string nextLine = "\r\n";

//----------------------------------------------------------
//       ,
//    textBox1
//----------------------------------------------------------
private void addFileContentsToTextBox(string fileName)
{
  //     
  System.IO.StreamReader myStreamReader;     
  myStreamReader = System.IO.File.OpenText(fileName);
  string fileText = myStreamReader.ReadToEnd();
  // 
  myStreamReader.Close();

  //   ,    
  textBox1.Text = textBox1.Text + 
    dividerLine+ "FILE: '" + fileName + "'" + nextLine + 
    dividerLine + fileText + nextLine;
}

//----------------------------------------------------------
//1.   ,
//         XML, 
//        
//
//2.      ,
//          ,
//         ,
//         XML, 
//        
//----------------------------------------------------------
private void button1_Click(object sender, System.EventArgs e)
{
  //    
  textBox1.Text = "";

  //===========================================
  //1.     
  //===========================================
  m_myDataSet = new System.Data.DataSet("HelloWorld-DataSet");

  //  ADO.NET DataSet   XML  
  //   
  m_myDataSet.WriteXml(FILE_EMPTY_DATASET);      
  addFileContentsToTextBox(FILE_EMPTY_DATASET);

  //==================================================
  //2.       ADO.NET,
  //     2     
  //==================================================
  System.Data.DataTable myTestTable;
  myTestTable = m_myDataSet.Tables.Add("TestTable");

  //------------------------------------
  // 2   
  //------------------------------------
  //     DataTable  DataSet
  myTestTable.Columns.Add("TestColumn0", 
                          typeof(System.DateTime));
  //     DataTable  DataSet
  myTestTable.Columns.Add("TestColumn1", typeof(string));

  //------------------------------------
  //    
  //------------------------------------
  //     
  object[] rowOfData;
  rowOfData = new object[2];
  // 0 -   
  rowOfData[0] = System.DateTime.Today;
  // 1 -   
  rowOfData[1] = "a string of data today";
  myTestTable.Rows.Add(rowOfData);

  //      
  object[] rowOfData2;
  rowOfData2 = new object[2];
  // 0 -   
  rowOfData2[0] = System.DateTime.Today.AddDays(1);

  // 1 -   
  rowOfData2[1] = "tomorrow's string";
  myTestTable.Rows.Add(rowOfData2);

  //   ADO.NET DataSet   XML  
  //   
  m_myDataSet.WriteXml(FILE_1TABLE_DATASET);      
  addFileContentsToTextBox(FILE_1TABLE_DATASET);
} // 
