//  
private void buttonCreateDatabase_Click(object sender, 
                                        System.EventArgs e)
{
  DatabaseAccess.CreateAndFillDatabase();
}

//       
private void buttonLoadGameData_Click(object sender, 
                                      System.EventArgs e)
{
  //  
  textBox1.Text = "";

  //   
  GameData.InitializeGameVocabulary();

  //        
  System.Text.StringBuilder thisStringBuilder;
  thisStringBuilder = new System.Text.StringBuilder();      
  foreach(VocabularyWord thisWord in GameData.AllWords)
  {
    thisStringBuilder.Append(thisWord.EnglishWord);
    thisStringBuilder.Append(" = ");
    thisStringBuilder.Append(
           thisWord.GermanWordWithArticleIfExists);
    thisStringBuilder.Append("\r\n"); // 
  }
  //     
  textBox1.Text = thisStringBuilder.ToString();
}
