//-----------------------------------------------------------------
//    
//
//        
//-----------------------------------------------------------------

using System;

internal class GameData
{
//     
private static System.Collections.ArrayList 
                m_vocabularyWords_All;
private static System.Collections.ArrayList 
                m_vocabularyWords_Nouns;
private static System.Collections.ArrayList 
                m_vocabularyWords_Verbs;
private static System.Collections.ArrayList 
                m_vocabularyWords_Adjectives;
private static System.Collections.ArrayList 
                m_vocabularyWords_Adverbs;
private static System.Collections.ArrayList 
                m_vocabularyWords_Prepositions;

public static bool isGameDataInitialized
{
  //  ,   
  get {return (m_vocabularyWords_All != null);}
}

//    
public static System.Collections.ArrayList AllWords
{
  get
  {
    // ,     
    if (m_vocabularyWords_All == null) 
        {InitializeGameVocabulary();}
    return m_vocabularyWords_All;
  }
}

//     
public static System.Collections.ArrayList Nouns
{
  get
  {
    // ,     
    if (m_vocabularyWords_Nouns == null) 
        {InitializeGameVocabulary();}
    return m_vocabularyWords_Nouns;
  }
}

//==========================================================
//     
//==========================================================
static public void InitializeGameVocabulary()
{
  //       
  m_vocabularyWords_All = new System.Collections.ArrayList();
  m_vocabularyWords_Nouns = new System.Collections.ArrayList();
  m_vocabularyWords_Verbs = new System.Collections.ArrayList();
  m_vocabularyWords_Adjectives = 
                            new System.Collections.ArrayList();
  m_vocabularyWords_Adverbs = 
                            new System.Collections.ArrayList();
  m_vocabularyWords_Prepositions = 
                            new System.Collections.ArrayList();

  System.Data.IDataReader dataReader;
  dataReader = DatabaseAccess.GetListOfWords();

  VocabularyWord newWord;
  //  
  while(dataReader.Read())
  {
    //        
    newWord = new VocabularyWord(
      dataReader.GetString(
        DatabaseAccess.DS_WORDS_COLUMNINDEX_ENGLISHWORD),

      dataReader.GetString(
        DatabaseAccess.DS_WORDS_COLUMNINDEX_GERMANWORD),

      (VocabularyWord.WordGender) dataReader.GetInt32(
        DatabaseAccess.DS_WORDS_COLUMNINDEX_GERMANGENDER),

      (VocabularyWord.WordFunction) dataReader.GetInt32(
        DatabaseAccess.DS_WORDS_COLUMNINDEX_WORDFUNCTION)
      );

    //     
    m_vocabularyWords_All.Add(newWord);

    //    ,  
    //      
    //  ,      
    if((newWord.getWordFunction & 
        VocabularyWord.WordFunction.Noun) != 0)
    {m_vocabularyWords_Nouns.Add(newWord);}

    if((newWord.getWordFunction & 
        VocabularyWord.WordFunction.Verb) != 0)
    {m_vocabularyWords_Verbs.Add(newWord);}

    if((newWord.getWordFunction & 
        VocabularyWord.WordFunction.Adjective) != 0)
    {m_vocabularyWords_Adjectives.Add(newWord);}

    if((newWord.getWordFunction & 
        VocabularyWord.WordFunction.Adverb) != 0)
    {m_vocabularyWords_Adverbs.Add(newWord);}

    if((newWord.getWordFunction & 
        VocabularyWord.WordFunction.Preposition) != 0)
    {m_vocabularyWords_Prepositions.Add(newWord);}
  
  }
  //  DataReader
  dataReader.Close();
}
} // 
