class MyStateMachineClass
{
  private enum GameState
  {
    StartScreen,
    AskQuestion,
    CongratulateUser,
    ScoldUser
  }
  private GameState m_CurrentGameState;

  //---------------------------------------------------------------------
  // ,    
  //        
  //    
  //---------------------------------------------------------------------
  private void StateChangeForGame(GameState  newGameUIState)
  {
    //,     
    switch(newGameUIState)
    {
      case GameState.StartScreen:
        //       ,
        //   ,  
        if ((m_CurrentGameState != GameState.CongratulateUser) 
          && (m_CurrentGameState != GameState.ScoldUser))
        {
          throw new System.Exception(" !");
        }

        // :   ,   :
        // 1.  (Hide),  (Show)  (Move) 
        //       
        // 2.  / , 
        //      
        //
        // SetUpGameStateForStartScreen();
        break;

      case GameState.AskQuestion:
        //       ,
        //   ,  
        if ((m_CurrentGameState != GameState.StartScreen)
          && (m_CurrentGameState != GameState.CongratulateUser)
          && (m_CurrentGameState != GameState.ScoldUser))
        {
          throw new System.Exception(" !");
        }

        // :   ,   :
        // 1.  (Hide),  (Show)  (Move) 
        //       
        // 2.  / , 
        //      
        //
        // SetUpGameStateForAskQuestion();
        break;

      case GameState.CongratulateUser:
        //       ,
        //   ,  
        if (m_CurrentGameState != GameState.AskQuestion) 
        {
          throw new System.Exception(" !");
        }

        // :   ,   :
        // 1.  (Hide),  (Show)  (Move) 
        //       
        // 2.  / , 
        //      
        //
        // SetUpGameStateForCongratulateUser();
        break;

      case GameState.ScoldUser:
        //       ,
        //   ,  
        if (m_CurrentGameState != GameState.AskQuestion) 
        {
          throw new System.Exception(" !");
        }

        // :   ,   :
        // 1.  (Hide),  (Show)  (Move) 
        //       
        // 2.  / , 
        //      
        //
        // SetUpGameStateForScoldUser();
        break;

      default:
        throw new System.Exception(" !");
    }

    //      
    m_CurrentGameState = newGameUIState;
  }
} // 
