using system;

public class GraphicsGlobals
{
private static  System.Drawing.Bitmap  s_Player_Bitmap1;
private static  System.Drawing.Bitmap  s_Player_Bitmap2;
private static  System.Drawing.Bitmap  s_Player_Bitmap3;
private static  System.Drawing.Bitmap  s_Player_Bitmap4;
private static  System.Collections.ArrayList s_colPlayerBitmaps;

  //---------------------------------------------------
  //  
  //---------------------------------------------------
  public static void g_PlayerBitmapsCollection_CleanUp()
  {
    //     ,       
    if(s_colPlayerBitmaps == null) { return;	}

    //      
    //    
    s_Player_Bitmap1.Dispose();  s_Player_Bitmap2.Dispose();
    s_Player_Bitmap3.Dispose();  s_Player_Bitmap4.Dispose();

    //    ,    
    //   
    s_Player_Bitmap1 = null;	  s_Player_Bitmap2 = null;
    s_Player_Bitmap3 = null;	  s_Player_Bitmap4 = null;

    //  
    s_colPlayerBitmaps = null;
  }	

  //:   
  public static System.Collections.ArrayList 
    g_PlayerBitmapsCollection()
  {
    //---------------------------------------------------------------
    //   ,    
    //---------------------------------------------------------------
    if(s_colPlayerBitmaps != null) {return s_colPlayerBitmaps;}

    //       
    System.Reflection.Assembly thisAssembly = 
      System.Reflection.Assembly.GetExecutingAssembly();

    System.Reflection.AssemblyName thisAssemblyName = 
      thisAssembly.GetName();
    
    string assemblyName = thisAssemblyName.Name;

    // 
    s_Player_Bitmap1 = new System.Drawing.Bitmap(
      thisAssembly.GetManifestResourceStream(assemblyName 
      + ".Hank_RightRun1.bmp"));

    s_Player_Bitmap2 = new System.Drawing.Bitmap(
      thisAssembly.GetManifestResourceStream(assemblyName + 
      ".Hank_RightRun2.bmp"));

    s_Player_Bitmap3 = new System.Drawing.Bitmap(
      thisAssembly.GetManifestResourceStream(assemblyName + 
      ".Hank_LeftRun1.bmp"));

    s_Player_Bitmap4 = new System.Drawing.Bitmap(
      thisAssembly.GetManifestResourceStream(assemblyName +
      ".Hank_LeftRun2.bmp"));


    //   
    s_colPlayerBitmaps = new System.Collections.ArrayList();
    s_colPlayerBitmaps.Add(s_Player_Bitmap1);
    s_colPlayerBitmaps.Add(s_Player_Bitmap2);

    s_colPlayerBitmaps.Add(s_Player_Bitmap3);
    s_colPlayerBitmaps.Add(s_Player_Bitmap4);

    // 
    return s_colPlayerBitmaps;
  }

  private static System.Drawing.Pen s_blackPen;
  private static System.Drawing.Pen s_whitePen;
  private static System.Drawing.Imaging.ImageAttributes 
    s_ImageAttribute;
 
  private static System.Drawing.Font s_boldFont;

  //------------------------------------------------
  //     
  //,    
  //------------------------------------------------
  private static void g_CleanUpDrawingResources()
  {
    //    ,   
    if(s_blackPen != null)
    {s_blackPen.Dispose(); s_blackPen = null;}

    //     ,   
    if(s_whitePen != null)
    {	s_whitePen.Dispose(); s_whitePen = null;}

    //    ImageAttribute,   .
    //.  Dispose()     ,
    //     
    if(s_ImageAttribute != null)
    {s_ImageAttribute = null;}

    //    ,   
    if(s_boldFont != null)
    {s_boldFont.Dispose(); s_boldFont = null;}
  }

  //-----------------------------------------
  //    
  //  ,   -
  //-----------------------------------------
  private static System.Drawing.Pen g_GetBlackPen()
  {
    //    ,  
    if(s_blackPen == null) 
    {
      s_blackPen = new System.Drawing.Pen(
        System.Drawing.Color.Black);
    }

    //  
    return s_blackPen;
  }

  //----------------------------------------
  //    
  //  ,   -
  //----------------------------------------
  private static System.Drawing.Pen g_GetWhitePen()
  {
    //    ,  
    if(s_whitePen == null) 
    {s_whitePen  = new System.Drawing.Pen(
       System.Drawing.Color.White);}

    //  
    return s_whitePen;
  }

  //-----------------------------------------------
  //    
  //  ,   -
  //-----------------------------------------------
  private static System.Drawing.Font g_GetBoldFont()
  {
    //    ,  
    if(s_boldFont == null) 
    {
      s_boldFont  = new System.Drawing.Font(
        System.Drawing.FontFamily.GenericSerif, 
        10, System.Drawing.FontStyle.Bold);
    }

    //   
    return s_boldFont;
  }

  //------------------------------------------------------
  //    
  //   -  imageAttributes,
  //       
  //------------------------------------------------------
  private static System.Drawing.Imaging.ImageAttributes 
    g_GetTransparencyImageAttribute()
  {
    //   ,  
    if(s_ImageAttribute == null)
    {
      //  
      s_ImageAttribute = 
        new System.Drawing.Imaging.ImageAttributes();

      s_ImageAttribute.SetColorKey(System.Drawing.Color.White, 
        System.Drawing.Color.White);
    }

    // 
    return s_ImageAttribute;
  }
} // 
