using System;

public class WastefulWorkerClass
{
  private string m_beginning_segment;
  public string BeginSegment
  {
    get { return m_beginning_segment;	}
    set { m_beginning_segment = value;	}
  }


  private string m_middle_segment;
  public string MiddleSegment
  {
    get	{	return m_middle_segment;	}
    set	{	m_middle_segment = value;}
  }

  private string m_end_segment;
  public string EndSegment
  {
    get	{	return m_end_segment;	}
    set	{	m_end_segment = value;}
  }

  public WastefulWorkerClass(string in_word)
  {
    int index_segment1;

    //    ("_")  
    index_segment1 = in_word.IndexOf("_",0);

    //    "_" ,   ,    
    if(index_segment1 == -1)
    {
      m_beginning_segment = in_word;
      m_middle_segment = "";
      m_end_segment = "";
      return;
    }

      //   "_",  
    else
    {
      //    "_",     ""
      if(index_segment1 == 0)
      {
        m_beginning_segment = "";
      }
      else
      {
        // 
        m_beginning_segment  = in_word.Substring(0, index_segment1);
      }

      //   "_"
      int index_segment2;
      index_segment2 = in_word.IndexOf("_", index_segment1 + 1);

      //  "_" 
      if(index_segment2 == -1)
      {
        m_middle_segment = "";
        m_end_segment = in_word.Substring(index_segment1 + 1);
        return;
      }

      //  
      m_middle_segment = in_word.Substring(index_segment1 + 1, 
                         index_segment2 - index_segment1 -1);

      m_end_segment = in_word.Substring(index_segment2 + 1);

    }
  }

  //   ,   "_" 
  public string getWholeString()
  {

    return m_beginning_segment + "_" + m_middle_segment + "_" +
           m_end_segment;
  }
	
} // 
